/*
About:		Skip Jack Crypt Algorithm (T-SQL implementation)
Author: 	David Janecka
Mail:		djanecka@seznam.cz
Version:	1.4
Release date:	12/9/2001	(format mm/dd/yyyy)
Licence:	$99 for commerce use
		after registration free for private use
		use support functions free
Registration:	http://www.sweb.cz/djanecka
************************COPYRIGHT NOTICE****************************************
 Copyright (C) 2001 David Janecka. All rights reserved.
 This code was originally written in T-SQL by David Janecka.
 It is PROHIBITED to distribute or reproduce this code for profit
 or otherwise, on any web site, ftp server or BBS, or by any
 other means, including CD-ROM or other physical media, without the
 EXPRESS WRITTEN PERMISSION of the author.
 Use at your own risk.
 David Janecka offer no warranty of its fitness for any purpose whatsoever,
 and accept no liability whatsoever for any loss or damage incurred by its use.
********************************************************************************
*/
Use Master
go
IF EXISTS (SELECT * FROM   sysobjects WHERE  name = N'InvG')
 Drop Function InvG
go
Create Function InvG(@Inp Int,@Pozice Int,@Klic nvarchar(100)) RETURNS BigInt As
BEGIN
Declare @Res bigint,@L int,@R int,@P int,
        @K0 int,@K1 int,@K2 int,@K3 int,
	@A int,@B int,@C int,@D int
 Set @L=(master.dbo.SHR(@inp,8)) % 256
 Set @R=@Inp % 256

 Set @K0=IsNull(ASCII(SubString(@Klic,((4*(@Pozice-1)) % 10)+1,1)),0)
 Set @K1=IsNull(ASCII(SubString(@Klic,(((4*(@Pozice-1))+1) % 10)+1,1)),0)
 Set @K2=IsNull(ASCII(SubString(@Klic,(((4*(@Pozice-1))+2) % 10)+1,1)),0)
 Set @K3=IsNull(ASCII(SubString(@Klic,(((4*(@Pozice-1))+3) % 10)+1,1)),0)
--Select statements included within a function cannot return data to a client.
 Set @P=@L ^ @K3
 Set @A=(Select SJ From SkipJack Where ID_SJ=@P)

 Set @P=@R ^ @A ^ @K2
 Set @B=(Select SJ From SkipJack Where ID_SJ=@P)

 Set @P=@L ^ @B ^ @K1
 Set @C=(Select SJ From SkipJack Where ID_SJ=@P) 

 Set @P=@R ^ @A ^ @C ^ @K0
 Set @D=(Select SJ From SkipJack Where ID_SJ=@P) 

 Set @L=@L ^ @B ^ @D
 Set @R=@R ^ @A ^ @C
 Set @Res=(@L*256)+@R
 Return @Res
END
go
IF EXISTS (SELECT * FROM   sysobjects WHERE  name = N'DeCrypt_SJ')
Drop Function DeCrypt_SJ
go
Create Function DeCrypt_SJ(@Crypt char(8),@Key nvarchar(10)) RETURNS CHAR(8) As
BEGIN
Declare @I int,@B int,@K int,@Plain nvarchar(100),
	@I1 int,@I2 int,@I3 int,@I4 int,
	@J1 int,@J2 int,@J3 int,@J4 int
--Inicializace
Set @I=32

Set @I1=master.dbo.StrToNum(SubString(@Crypt,1,1)+SubString(@Crypt,2,1))
Set @I2=master.dbo.StrToNum(SubString(@Crypt,3,1)+SubString(@Crypt,4,1))
Set @I3=master.dbo.StrToNum(SubString(@Crypt,5,1)+SubString(@Crypt,6,1))
Set @I4=master.dbo.StrToNum(SubString(@Crypt,7,1)+SubString(@Crypt,8,1))

While @I>=1
Begin
 Set @B=Case
   When (@I>=1 and @I<=8)   Then 	0
   When (@I>=9 and @I<=16)  Then 	1
   When (@I>=17 and @I<=24) Then 	0
   When (@I>=25 and @I<=32) Then	1
 END 
 If @B=0
	Begin
	 Set @K=master.dbo.InvG(@I2,@I,@Key) 
	 Set @J1=@K
	 Set @J2=@I3
	 Set @J3=@I4
	 Set @J4=@I1 ^ @I2 ^ @I

	 Set @I1=@J1
	 Set @I2=@J2
	 Set @I3=@J3
	 Set @I4=@J4
	End
 Else
	Begin
	 Set @K=master.dbo.InvG(@I2,@I,@Key) 
	 Set @J1=@K
	 Set @J2=@K ^ @I3 ^ @I
	 Set @J3=@I4
	 Set @J4=@I1

	 Set @I1=@J1
	 Set @I2=@J2
	 Set @I3=@J3
	 Set @I4=@J4
	End
 Set @I=@I-1
End
Set @Plain=master.dbo.NumToStr(@I1)+master.dbo.NumToStr(@I2)+master.dbo.NumToStr(@I3)+master.dbo.NumToStr(@I4)
Return @Plain
END
go
IF EXISTS (SELECT * FROM   sysobjects WHERE  name = N'DeCryptText')
 Drop Function DeCryptText
go
Create Function DeCryptText(@CryptText nvarchar(4000),@CryptKey nvarchar(10)) RETURNS nvarchar(4000) As
BEGIN
Declare @Res nvarchar(4000),@I int,@L int,@J int,@Buff char(8)
Set @Res=''
Set @Buff=''
Set @I=0
Set @L=Len(@CryptText)
Set @J=@L / 8
While @I<@J
Begin
 Set @Buff=SubString(@CryptText,(@I*8+1),8)
 Set @Res=@Res+master.dbo.DeCrypt_SJ(@Buff,@CryptKey)
 Set @I=@I+1
End
Set @Res=RTrim(@Res)
Return @Res
END