/*
							SAMPLES
About:		Skip Jack Crypt Algorithm (T-SQL implementation)
Author: 	David Janecka
Mail:		djanecka@seznam.cz
Version:	1.4
Release date:	12/9/2001	(format mm/dd/yyyy)
Licence:	$99 for commerce use
		after registration free for private use
		use support functions free
Registration:	http://www.sweb.cz/djanecka
************************COPYRIGHT NOTICE****************************************
 Copyright (C) 2001 David Janecka. All rights reserved.
 This code was originally written in T-SQL by David Janecka.
 It is PROHIBITED to distribute or reproduce this code for profit
 or otherwise, on any web site, ftp server or BBS, or by any
 other means, including CD-ROM or other physical media, without the
 EXPRESS WRITTEN PERMISSION of the author.
 Use at your own risk.
 David Janecka offer no warranty of its fitness for any purpose whatsoever,
 and accept no liability whatsoever for any loss or damage incurred by its use.
********************************************************************************
*/
--If not exists, create it or use exists
use test
go
--Simple use 
Declare @C nvarchar(50)
Set @C=master.dbo.CryptText('I love T-SQL, it''s great!','secret key')
Print @C
Print master.dbo.DeCryptText(@C,'secret key')
--no key
Set @C=master.dbo.CryptText('plain text with no key','')
Print @C
Print master.dbo.DeCryptText(@C,'')
go
--Use in batch statement
If Exists(Select Name From SysObjects Where Name='Customer' and type='U')
 Drop Table Customer
go
Create Table Customer(
 Id_C int Identity(1,1) Not Null,
 Customer_Name nvarchar(60) Not Null)
go
 Set NoCount On
 Insert Into Customer(Customer_Name) Values('Jonh White')
 Insert Into Customer(Customer_Name) Values('Jerry Wemeno')
 Insert Into Customer(Customer_Name) Values('Jeff Brown')
go
--Crypt Table
Update Customer Set Customer_Name=master.dbo.CryptText(Customer_Name,'Wq82+ *loD')
--Insert crypt record
Insert Into Customer(Customer_Name) Values(master.dbo.CryptText('George Green','Wq82+ *loD'))
--Select within Decrypt
Select * From Customer
--Select with Decrypt
Select master.dbo.DeCryptText(Customer_Name,'Wq82+ *loD') as Customer_Name From Customer
--Batch decrypt table
Update Customer Set Customer_Name=master.dbo.DeCryptText(Customer_Name,'Wq82+ *loD')
Select * From Customer
go
--Use as Trigger
Truncate Table Customer
go
If Exists(Select Name From SysObjects Where Name='CryptTR' and type='TR')
 Drop Trigger CryptTR
go
Create Trigger CryptTR on Customer With Encryption For Insert  As
Update Customer 
Set Customer.Customer_Name=master.dbo.CryptText(Inserted.Customer_Name,'Wq82+ *loD')
From Inserted Where Inserted.ID_C=Customer.ID_C
go
--Fire Trigger
Insert Into Customer(Customer_Name) Values('Jonh White')
Insert Into Customer(Customer_Name) Values('Jerry Wemeno')
Insert Into Customer(Customer_Name) Values('Jeff Brown')
--Batch Insert from CSV File, copy file at specified path
Exec sp_addlinkedserver MyTxt,'Jet 4.0','Microsoft.Jet.OLEDB.4.0','d:\',NULL,'Text'
go
Insert Into Customer(Customer_Name) Select Customer_Name From MyTxt...[customer#csv]
go
Exec sp_dropserver 'MyTxt',Null
go
Select Customer_Name From Customer
Select master.dbo.DeCryptText(Customer_Name,'Wq82+ *loD') as Customer_Name From Customer
go

