/*
				SUPPORT FUNCTIONS

About:		Skip Jack Crypt Algorithm (T-SQL implementation)
Author: 	David Janecka
Mail:		djanecka@seznam.cz
Version:	1.4
Release date:	12/9/2001	(format mm/dd/yyyy)
Licence:	$99 for commerce use
		after registration free for private use
		use support functions free
Registration:	http://www.sweb.cz/djanecka
************************COPYRIGHT NOTICE****************************************
 Copyright (C) 2001 David Janecka. All rights reserved.
 This code was originally written in T-SQL by David Janecka.
 It is PROHIBITED to distribute or reproduce this code for profit
 or otherwise, on any web site, ftp server or BBS, or by any
 other means, including CD-ROM or other physical media, without the
 EXPRESS WRITTEN PERMISSION of the author.
 Use at your own risk.
 David Janecka offer no warranty of its fitness for any purpose whatsoever,
 and accept no liability whatsoever for any loss or damage incurred by its use.
********************************************************************************
*/
IF EXISTS (SELECT * FROM   sysobjects WHERE  name = N'Exponential')
 DROP FUNCTION Exponential
go
Create Function Exponential(@Root Int,@Exp Int) RETURNS BigInt As
BEGIN
Declare @Res BigInt
Set @Res=CEILING(Exp(@Exp*Log(@Root)))
Return @Res
END
go
IF EXISTS (SELECT * FROM   sysobjects WHERE  name = N'SHL')
 Drop Function SHL
go
Create Function SHL (@C1 int,@C2 int) RETURNS BIGINT AS
BEGIN
Declare @res bigint
Set @res=@C1*master.dbo.Exponential(2,@C2)
Return @res
END
go
IF EXISTS (SELECT * FROM   sysobjects WHERE  name = N'SHR')
 Drop Function SHR
go
Create Function SHR(@C1 bigint,@C2 bigint) RETURNS BIGINT AS
BEGIN
Declare @res bigint
Set @res=@C1/master.dbo.Exponential(2,@C2)
Return @res
END
go
IF EXISTS (SELECT * FROM   sysobjects WHERE  name = N'StrToNum')
Drop Function StrToNum
go
Create Function StrToNum(@S char(2)) RETURNS INT AS
BEGIN
Declare @Res int,@O1 int, @O2 int
Set @O1=Ascii(Substring(@S,1,1))
Set @O2=Ascii(Substring(@S,2,1))
Set @Res=master.dbo.SHL(@O1,8)+@O2
Return @Res
END
go
IF EXISTS (SELECT * FROM   sysobjects WHERE  name = N'NumToStr')
 Drop Function NumToStr
go
Create Function NumToStr(@HiLo int) RETURNS Char(2) As
BEGIN
 Declare @Res char(2),@L int, @R int
 Set @L=master.dbo.SHR(@HiLo,8)
 Set @R=@HiLo % 256
 Set @Res=Char(@L)+Char(@R)
 Return @Res
END
